# HG changeset patch
# User Torsten <mttl@mailbox.org>
# Date 1529870055 -7200
#      Sun Jun 24 21:54:15 2018 +0200
# Node ID 3cb6a967cf5caa4c7cbc9213c57920cef365fd1e
# Parent  b3c68525ed82260891bc135ff546569e8d5a35ca
use a custom title bar widget for the main dock widgets

* documentation-dock-widget.cc (documentation_dock_widget):
  replace setWindowTitle () by set_title () which uses a custom title bar
* files-dock-widget.cc (files_dock_widgets): dito
* history-dock-widget.cc (history_dock_widgets): dito
* file-editor.cc (construct): dito
* terminal-dock-widget.cc (terminal_dock_widgets): dito
* variable-editor.cc (variable_editor): dito
* workspace-view.cc (workspace_view): dito

diff -r b3c68525ed82 -r 3cb6a967cf5c libgui/src/documentation-dock-widget.cc
--- a/libgui/src/documentation-dock-widget.cc	Thu Jun 21 12:42:11 2018 -0400
+++ b/libgui/src/documentation-dock-widget.cc	Sun Jun 24 21:54:15 2018 +0200
@@ -35,7 +35,7 @@ namespace octave
     : octave_dock_widget ("DocumentationDockWidget", p)
   {
     setWindowIcon (QIcon (":/actions/icons/logo.png"));
-    setWindowTitle (tr ("Documentation"));
+    set_title (tr ("Documentation"));
     setStatusTip (tr ("See the documentation for help."));
 
     m_docs = new documentation (this);
diff -r b3c68525ed82 -r 3cb6a967cf5c libgui/src/files-dock-widget.cc
--- a/libgui/src/files-dock-widget.cc	Thu Jun 21 12:42:11 2018 -0400
+++ b/libgui/src/files-dock-widget.cc	Sun Jun 24 21:54:15 2018 +0200
@@ -69,7 +69,7 @@ namespace octave
     : octave_dock_widget ("FilesDockWidget", p)
   {
     setWindowIcon (QIcon (":/actions/icons/logo.png"));
-    setWindowTitle (tr ("File Browser"));
+    set_title (tr ("File Browser"));
     setToolTip (tr ("Browse your files"));
 
     m_sig_mapper = nullptr;
diff -r b3c68525ed82 -r 3cb6a967cf5c libgui/src/history-dock-widget.cc
--- a/libgui/src/history-dock-widget.cc	Thu Jun 21 12:42:11 2018 -0400
+++ b/libgui/src/history-dock-widget.cc	Sun Jun 24 21:54:15 2018 +0200
@@ -293,7 +293,7 @@ namespace octave
     m_filter_checkbox = new QCheckBox ();
 
     setWindowIcon (QIcon (":/actions/icons/logo.png"));
-    setWindowTitle (tr ("Command History"));
+    set_title (tr ("Command History"));
     setWidget (new QWidget ());
 
     m_filter_widget = new QWidget (this);
diff -r b3c68525ed82 -r 3cb6a967cf5c libgui/src/m-editor/file-editor.cc
--- a/libgui/src/m-editor/file-editor.cc	Thu Jun 21 12:42:11 2018 -0400
+++ b/libgui/src/m-editor/file-editor.cc	Sun Jun 24 21:54:15 2018 +0200
@@ -2046,7 +2046,7 @@ namespace octave
 
     resize (500, 400);
     setWindowIcon (QIcon (":/actions/icons/logo.png"));
-    setWindowTitle (tr ("Editor"));
+    set_title (tr ("Editor"));
 
     check_actions ();
   }
diff -r b3c68525ed82 -r 3cb6a967cf5c libgui/src/terminal-dock-widget.cc
--- a/libgui/src/terminal-dock-widget.cc	Thu Jun 21 12:42:11 2018 -0400
+++ b/libgui/src/terminal-dock-widget.cc	Sun Jun 24 21:54:15 2018 +0200
@@ -45,7 +45,7 @@ namespace octave
     m_terminal->setFocusPolicy (Qt::StrongFocus);
 
     setWindowIcon (QIcon (":/actions/icons/logo.png"));
-    setWindowTitle (tr ("Command Window"));
+    set_title (tr ("Command Window"));
 
     setWidget (m_terminal);
     setFocusProxy (m_terminal);
diff -r b3c68525ed82 -r 3cb6a967cf5c libgui/src/variable-editor.cc
--- a/libgui/src/variable-editor.cc	Thu Jun 21 12:42:11 2018 -0400
+++ b/libgui/src/variable-editor.cc	Sun Jun 24 21:54:15 2018 +0200
@@ -1043,7 +1043,7 @@ namespace octave
       m_focus_widget (nullptr),
       m_focus_widget_vdw (nullptr)
   {
-    setWindowTitle (tr ("Variable Editor"));
+    set_title (tr ("Variable Editor"));
     setStatusTip (tr ("Edit variables."));
     setWindowIcon (QIcon (":/actions/icons/logo.png"));
     setAttribute (Qt::WA_AlwaysShowToolTips);
diff -r b3c68525ed82 -r 3cb6a967cf5c libgui/src/workspace-view.cc
--- a/libgui/src/workspace-view.cc	Thu Jun 21 12:42:11 2018 -0400
+++ b/libgui/src/workspace-view.cc	Sun Jun 24 21:54:15 2018 +0200
@@ -51,7 +51,7 @@ namespace octave
     : octave_dock_widget ("WorkspaceView", p), m_view (new QTableView (this))
   {
     setWindowIcon (QIcon (":/actions/icons/logo.png"));
-    setWindowTitle (tr ("Workspace"));
+    set_title (tr ("Workspace"));
     setStatusTip (tr ("View the variables in the active workspace."));
 
     m_filter = new QComboBox (this);