# HG changeset patch
# User Markus Mützel <markus.muetzel@gmx.de>
# Date 1544473941 -3600
#      Mon Dec 10 21:32:21 2018 +0100
# Node ID c4aef86f41096a0630fcba9d8ec850a15153747b
# Parent  37cc0e3b1efe03877b6944b2682b70e3891c7b65
build-m4: Add patch for glibc >= 2.28 (bug #55214).

* src/build-m4-glibc2-28.patch: Add patch for m4 on systems with glibc >= 2.28.

* dist-files.mk: add ref to patch.

diff -r 37cc0e3b1efe -r c4aef86f4109 dist-files.mk
--- a/dist-files.mk	Fri Dec 07 11:51:16 2018 -0500
+++ b/dist-files.mk	Mon Dec 10 21:32:21 2018 +0100
@@ -34,6 +34,7 @@
   build-libtool.mk \
   build-lzip.mk \
   build-m4.mk \
+  build-m4-glib2-28.patch \
   build-mako.mk \
   build-markupsafe.mk \
   build-msvctools.mk \
diff -r 37cc0e3b1efe -r c4aef86f4109 src/build-m4-glibc2-28.patch
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/build-m4-glibc2-28.patch	Mon Dec 10 21:32:21 2018 +0100
@@ -0,0 +1,123 @@
+# This file is based on a Debian patch:
+# https://launchpadlibrarian.net/392968582/m4_1.4.18-1_1.4.18-1ubuntu1.diff.gz
+
+diff -upr a/lib/fflush.c b/lib/fflush.c
+--- a/lib/fflush.c     2016-12-31 21:54:41.000000000 +0800
++++ b/lib/fflush.c     2018-08-08 16:12:40.522952171 +0800
+@@ -33,7 +33,7 @@
+ #undef fflush
+ 
+ 
+-#if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++#if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+ 
+ /* Clear the stream's ungetc buffer, preserving the value of ftello (fp).  */
+ static void
+@@ -72,7 +72,7 @@ clear_ungetc_buffer (FILE *fp)
+ 
+ #endif
+ 
+-#if ! (defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */)
++#if ! (defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */)
+ 
+ # if (defined __sferror || defined __DragonFly__ || defined __ANDROID__) && defined __SNPT
+ /* FreeBSD, NetBSD, OpenBSD, DragonFly, Mac OS X, Cygwin, Android */
+@@ -148,7 +148,7 @@ rpl_fflush (FILE *stream)
+   if (stream == NULL || ! freading (stream))
+     return fflush (stream);
+ 
+-#if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++#if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+ 
+   clear_ungetc_buffer_preserving_position (stream);
+
+diff -upr a/lib/fpending.c b/lib/fpending.c
+--- a/lib/fpending.c     2016-12-31 21:54:41.000000000 +0800
++++ b/lib/fpending.c     2018-08-08 16:12:40.522952171 +0800
+@@ -32,7 +32,7 @@ __fpending (FILE *fp)
+   /* Most systems provide FILE as a struct and the necessary bitmask in
+      <stdio.h>, because they need it for implementing getc() and putc() as
+      fast macros.  */
+-#if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++#if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+   return fp->_IO_write_ptr - fp->_IO_write_base;
+ #elif defined __sferror || defined __DragonFly__ || defined __ANDROID__
+   /* FreeBSD, NetBSD, OpenBSD, DragonFly, Mac OS X, Cygwin, Android */
+
+diff -upr a/lib/fpurge.c b/lib/fpurge.c
+--- a/lib/fpurge.c     2016-12-31 21:54:41.000000000 +0800
++++ b/lib/fpurge.c     2018-08-08 16:12:40.522952171 +0800
+@@ -62,7 +62,7 @@ fpurge (FILE *fp)
+   /* Most systems provide FILE as a struct and the necessary bitmask in
+      <stdio.h>, because they need it for implementing getc() and putc() as
+      fast macros.  */
+-# if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++# if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+   fp->_IO_read_end = fp->_IO_read_ptr;
+   fp->_IO_write_ptr = fp->_IO_write_base;
+   /* Avoid memory leak when there is an active ungetc buffer.  */
+
+diff -upr a/lib/freadahead.c b/lib/freadahead.c
+--- a/lib/freadahead.c     2016-12-31 21:54:41.000000000 +0800
++++ b/lib/freadahead.c     2018-08-08 16:12:40.522952171 +0800
+@@ -25,7 +25,7 @@
+ size_t
+ freadahead (FILE *fp)
+ {
+-#if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++#if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+   if (fp->_IO_write_ptr > fp->_IO_write_base)
+     return 0;
+   return (fp->_IO_read_end - fp->_IO_read_ptr)
+
+diff -upr a/lib/freading.c b/lib/freading.c
+--- a/lib/freading.c    2016-12-31 21:54:41.000000000 +0800
++++ b/lib/freading.c    2018-08-08 16:13:12.399618677 +0800
+@@ -31,7 +31,7 @@ freading (FILE *fp)
+   /* Most systems provide FILE as a struct and the necessary bitmask in
+      <stdio.h>, because they need it for implementing getc() and putc() as
+      fast macros.  */
+-# if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++# if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+   return ((fp->_flags & _IO_NO_WRITES) != 0
+           || ((fp->_flags & (_IO_NO_READS | _IO_CURRENTLY_PUTTING)) == 0
+               && fp->_IO_read_base != NULL));
+
+diff -upr a/lib/fseeko.c b/lib/fseeko.c
+--- a/lib/fseeko.c    2016-12-31 21:54:41.000000000 +0800
++++ b/lib/fseeko.c    2018-08-08 16:13:12.399618677 +0800
+@@ -47,7 +47,7 @@ fseeko (FILE *fp, off_t offset, int when
+ #endif
+ 
+   /* These tests are based on fpurge.c.  */
+-#if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++#if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+   if (fp->_IO_read_end == fp->_IO_read_ptr
+       && fp->_IO_write_ptr == fp->_IO_write_base
+       && fp->_IO_save_base == NULL)
+@@ -123,7 +123,7 @@ fseeko (FILE *fp, off_t offset, int when
+           return -1;
+         }
+ 
+-#if defined _IO_ftrylockfile || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
++#if defined _IO_EOF_SEEN || __GNU_LIBRARY__ == 1 /* GNU libc, BeOS, Haiku, Linux libc5 */
+       fp->_flags &= ~_IO_EOF_SEEN;
+       fp->_offset = pos;
+ #elif defined __sferror || defined __DragonFly__ || defined __ANDROID__
+
+diff -upr a/lib/stdio-impl.h b/lib/stdio-impl.h
+--- a/lib/stdio-impl.h    2016-12-31 21:54:41.000000000 +0800
++++ b/lib/stdio-impl.h    2018-08-08 16:13:12.399618677 +0800
+@@ -18,6 +18,12 @@
+    the same implementation of stdio extension API, except that some fields
+    have different naming conventions, or their access requires some casts.  */
+ 
++/* Glibc 2.28 made _IO_IN_BACKUP private.  For now, work around this
++   problem by defining it ourselves.  FIXME: Do not rely on glibc
++   internals.  */
++#if !defined _IO_IN_BACKUP && defined _IO_EOF_SEEN
++# define _IO_IN_BACKUP 0x100
++#endif
+ 
+ /* BSD stdio derived implementations.  */
+